-- $Id: prepaid-tables.sql,v 1.4 2004/11/15 11:20:00 peternixon Exp $
-- prepaid-struct 2.1.0

-- TODO: indexes !!!
-- TODO: referential INTEGRITY!!! add checks to all accessing programs

-- primary keys, indexes
-- foreign keys, relational integrity
-- max failsafe checks

CREATE TABLE call (
    id bigserial PRIMARY KEY,
    sessionid text NOT NULL,
    uniqueid text NOT NULL,
    username text NOT NULL,
    nasipaddress text,
    starttime timestamp,
    stoptime timestamp,
    sessiontime integer,
    calledstation text,
    startdelay integer,
    stopdelay integer,
    terminatecause text,
    usertariff text,
    calledprovider text,
    calledcountry text,
    calledsub text,
    calledrate integer,
    sessionbill integer
);

CREATE TABLE sale (
    id serial PRIMARY KEY,
    username text NOT NULL,
    cardid integer NOT NULL,
    saletime timestamp NOT NULL,
    saletype text NOT NULL,
    credit integer NOT NULL,
    discount integer NOT NULL
);

CREATE TABLE reseller (
    id serial PRIMARY KEY,
    username text NOT NULL,
    userpass text NOT NULL,
    description text NOT NULL,
    credit integer NOT NULL,
    discount integer NOT NULL,
    admin boolean DEFAULT 'n' NOT NULL
);

CREATE TABLE card (
    id bigserial PRIMARY KEY,
    username text NOT NULL,
    userpass text NOT NULL,
    credit integer NOT NULL,
    tariff text NOT NULL,
    activated boolean DEFAULT 'n' NOT NULL
);

CREATE TABLE resellercard (
    resellerid integer NOT NULL,
    cardid integer NOT NULL
);

CREATE TABLE country (
    id serial PRIMARY KEY,
    countrycode text NOT NULL,
    countryname text NOT NULL
);

CREATE TABLE tariff (
    id serial PRIMARY KEY,
    tariffcode text NOT NULL,
    tariffname text NOT NULL
);

CREATE TABLE provider (
    id serial PRIMARY KEY,
    prefix text DEFAULT '' NOT NULL,
    providercode text NOT NULL,
    providertech text NOT NULL,
    providerip text NOT NULL
);

CREATE TABLE providerdestination (
    id serial PRIMARY KEY,
    destination text NOT NULL,
    providercode text NOT NULL
);

CREATE TABLE internationalprefix (
    id serial PRIMARY KEY,
    prefix text NOT NULL
);

CREATE TABLE countryprefix (
    id serial PRIMARY KEY,
    prefix text NOT NULL,
    countrycode text NOT NULL,
    subcode text NOT NULL
);

CREATE TABLE tariffrate (
    id serial PRIMARY KEY,
    startdate date,
    stopdate date,
    tariffcode text NOT NULL,
    countrycode text NOT NULL,
    subcode text NOT NULL,
    rate integer NOT NULL
);

CREATE TABLE providerrate (
    id serial PRIMARY KEY,
    startdate date,
    stopdate date,
    providercode text NOT NULL,
    countrycode text NOT NULL,
    subcode text NOT NULL,
    rate real NOT NULL
);

CREATE TABLE callerid (
    id bigserial PRIMARY KEY,
    cid text NOT NULL,
    username text NOT NULL,
    customerid integer NOT NULL,
    activated boolean DEFAULT 'y' NOT NULL
);
